#version 300 es

precision highp float;

uniform sampler2D u_Texture;
uniform float u_PointRange;
uniform vec2 u_Offset;
uniform float u_Jump;
uniform int u_AddSrc;

layout(location = 0) out vec4 o_FragColor;

in highp vec2 v_TexCoord;

void main() {
    vec4 src = texture(u_Texture, v_TexCoord);
    vec4 color = vec4(0.0);
    vec2 point;
    int count = 0;

    for(float u = -u_PointRange; u < u_PointRange; u += u_Jump) {
        for(float v = -u_PointRange; v < u_PointRange; v += u_Jump) {
            point.x = v_TexCoord.x  + u * u_Offset.x;
            point.y = v_TexCoord.y  + v * u_Offset.y;
            count += 1;
            color += texture(u_Texture, point.xy);
        }
    }

    o_FragColor = color / float(count) + (u_AddSrc == 1 ? src : vec4(0.0));
}
