#version 300 es

precision highp float;

uniform sampler2D u_LDMask;
uniform sampler2D u_InterLDMask;
uniform int u_Mode;
uniform float u_Intensity;
in vec2 v_TexCoord;

layout(location = 0) out vec4 o_FragColor;

float map(float value, float inMin, float inMax, float outMin, float outMax) {
    return (value - inMin) * (outMax - outMin) / (inMax - inMin) + outMin;
}

void main() {
    vec2 ld = texture(u_LDMask, v_TexCoord).rg;
    float rawI = texture(u_InterLDMask, v_TexCoord).r;
    float i = rawI * u_Intensity;
    float d = 0.0;
    float l = 0.0;

    if (u_Intensity > 0.0) {
        if (u_Mode == 0) {
            if (ld.g > 0.0) {
                l = ld.g * (1.0 - map(i, 0.0, u_Intensity, 0.0, 1.0)) - i;

                if (l < 0.0) {
                    d = -l;
                    l = 0.0;
                }
            } else {
                l = 0.0;
                d = ld.r * (1.0 - map(i, 0.0, u_Intensity, 0.0, 1.0)) + i;
            }
        } else {
            if (ld.r > 0.0) {
                d = ld.r * (1.0 - map(i, 0.0, u_Intensity, 0.0, 1.0)) - i;

                if (d < 0.0) {
                    l = -d;
                    d = 0.0;
                }
            } else {
                d = 0.0;
                l = ld.g * (1.0 - map(i, 0.0, u_Intensity, 0.0, 1.0)) + i;
            }
        }
    } else {
        d = clamp(ld.r - rawI * ld.r, 0.0, 1.0);
        l = clamp(ld.g - rawI * ld.g, 0.0, 1.0);
    }


    o_FragColor = vec4(d, l, 0.0, 1.0);
}