#version 300 es

precision highp float;

uniform float u_RRand; // 0..1
uniform float u_GRand; // 0..1
uniform float u_BRand; // 0..1

uniform float u_XF;
uniform float u_YF;
uniform sampler2D u_Mask;

uniform float u_Precision; // 1..500

in vec2 v_GCoord;

const float c_Precision = 500.0;

layout(location = 0) out vec4 o_FragColor;

float rand(float x, float y)
{
    return fract(sin(dot(vec2(x, y), vec2(12.9898, 78.233))) * 43758.5453);
}

void main( void ) {
    float x = floor(v_GCoord.x * u_XF * u_Precision) / u_Precision;
    float y = floor(v_GCoord.y * u_YF * u_Precision) / u_Precision;
    vec2 texCoords = vec2(v_GCoord.x + 0.5, 1.0 - (v_GCoord.y + 0.5));
    float a = texture(u_Mask, texCoords).r;

    if (abs(x) < 0.000001) {
        x += v_GCoord.x > 0.0 ? u_RRand : -u_GRand;
    }

    if (abs(y) < 0.000001) {
        y += v_GCoord.y > 0.0 ? u_GRand : -u_BRand;
    }

	float r = rand(y + cos(u_RRand), x + sin(u_RRand));
	float g = rand(y + cos(u_GRand), x + sin(u_GRand));
	float b = rand(y + cos(u_BRand), x + sin(u_BRand));

	o_FragColor = vec4(r, g, b, 1.0) * a;
}