#version 300 es

precision highp float;

uniform sampler2D u_Texture;
uniform vec2 u_Size;
uniform vec2 u_Direction;

layout(location = 0) out vec4 o_FragColor;

in highp vec2 v_TexCoord;

vec4 blur5() {
    vec4 color = vec4(0.0);
    vec2 off1 = vec2(1.3333333333333333) * u_Direction;
    float c1 = texture(u_Texture, v_TexCoord).r;
    float c2 = texture(u_Texture, v_TexCoord + (off1 / u_Size)).r;
    float c3 = texture(u_Texture, v_TexCoord - (off1 / u_Size)).r;
    float c = c1 * 0.29411764705882354 + c2 * 0.35294117647058826 + c3 * 0.35294117647058826;

    return vec4(c, 0.0, 0.0, 1.0);
}

void main() {
    o_FragColor = blur5();
}
