#version 300 es

precision highp float;

in highp vec2 v_TexCoord;

uniform sampler2D u_Texture;

layout(location = 0) out vec4 o_Red;
layout(location = 1) out vec4 o_Green;
layout(location = 2) out vec4 o_Blue;


void main() {
    vec4 color = texture(u_Texture, v_TexCoord);
    float s = color.r + color.g + color.b;
    float ra;
    float ga;
    float ba;

    if (s == 0.0 && color.a > 0.0) {
        float a = color.a / 3.0;

        ra = a;
        ga = a;
        ba = a;
    } else {
        ra = color.a * color.r / s;
        ga = color.a * color.g / s;
        ba = color.a * color.b / s;
    }


    o_Red = vec4(color.r, ra, 0.0, 1.0);
    o_Green = vec4(color.g, ga, 0.0, 1.0);
    o_Blue = vec4(color.b, ba, 0.0, 1.0);


    /*if (!(color.r == 0. && color.g == 0. && color.b == 0.)) {
        if (color.r == 0.) {
            o_Red.g = 0.;
        }

        if (color.g == 0.) {
           o_Green.g = 0.;
        }

        if (color.b == 0.) {
           o_Blue.g = 0.;
        }
    }*/

}
