#version 300 es

precision highp float;

in highp vec2 v_TexCoord;
uniform sampler2D u_RedTexture;
uniform sampler2D u_GreenTexture;
uniform sampler2D u_BlueTexture;
uniform int u_BlendMode;

layout(location = 0) out vec4 o_FragColor;

float alpha(vec2 red, vec2 green, vec2 blue) {
    if(red.r > green.r && red.r > blue.r) {
        return red.g;
    }
    if(green.r > red.r && green.r > blue.r) {
            return green.g;
    }
    if(blue.r > green.r && blue.r > red.r) {
             return blue.g;
    }
    return (red.g + green.g + blue.g) / 3.;
}

float minNot0(float a1, float a2) {
    float min = min(a1, a2);

    return min > 0. ? min : (a1 > 0. ? a1 : a2);
}

void main() {
    vec2 red = texture(u_RedTexture, v_TexCoord).rg;
    vec2 green = texture(u_GreenTexture, v_TexCoord).rg;
    vec2 blue = texture(u_BlueTexture, v_TexCoord).rg;

    vec3 c = vec3(red.r, green.r, blue.r);

    float a =  red.g + green.g + blue.g;

    o_FragColor = vec4(c, a * float(1 - u_BlendMode) + 1.0 * float(u_BlendMode));
}

