#version 300 es

in vec4 a_Position;
in vec2 a_TexCoord;

uniform mat4 u_ProjM;
uniform mat4 u_ModelM;
uniform float u_InputWidth;
uniform float u_InputHeight;

out vec2 v_TexCoord;
out vec2 v_LeftTexCoord;
out vec2 v_RightTexCoord;
out vec2 v_TopTexCoord;
out vec2 v_BottomTexCoord;

void main()
{
    mat4 mvp = u_ProjM * u_ModelM;
    gl_Position = mvp * a_Position;
    v_TexCoord = a_TexCoord;

    vec2 widthStep = vec2(1.0 / u_InputWidth, 0.0);
    vec2 heightStep = vec2(0.0, 1.0 / u_InputHeight);

    v_LeftTexCoord = a_TexCoord - widthStep;
    v_RightTexCoord = a_TexCoord + widthStep;
    v_TopTexCoord = a_TexCoord + heightStep;
    v_BottomTexCoord = a_TexCoord - heightStep;
}