#version 300 es

in vec4 a_Position;
in vec2 a_Normal;
in vec2 a_Miter;

uniform mat4 u_ProjM;
uniform mat4 u_ModelM;
uniform mat4 u_TexModelM;
uniform vec2 u_ImgSize;
uniform float u_Thickness;

out vec2 v_TexCoord;

void main()
{
    mat4 mvp = u_ProjM * u_ModelM;
    float len = a_Miter.x == 0.0 && a_Miter.y == 0.0 ? 0.0 : u_Thickness / dot(a_Miter, a_Normal);
    vec4 pos = a_Position + vec4(a_Miter * len, 0.0, 0.0);
    gl_Position = mvp * pos;
    v_TexCoord = (u_TexModelM * pos).xy / u_ImgSize;
}